var mRetryCount = 0;

jQuery(document).ready( function() {
  if (document.getElementById("cw_feedzilla_loading")) {
    jQuery("#cw_feedzilla_loading").show();
    jQuery("#cw_feedzilla_messages").hide();

    getCultures();
    getCategories();
    getSubcategories();
    getArticles();

    jQuery("#cw_feedzilla_cultures").on("change", function() {
      if (localStorage) {
	if (mRetryCount++ >= 3) {
	  localStorage.setItem("cw_feedzilla_culture", jQuery("#cw_feedzilla_cultures").val());
	} else {
	  getCategories();
	}
      }
    });

    jQuery("#cw_feedzilla_categories").on("change", function() {
      if (localStorage) {
	localStorage.setItem("cw_feedzilla_category", jQuery("#cw_feedzilla_categories").val());
	getSubcategories();
      }
    });

    jQuery("#cw_feedzilla_subcategories").on("change", function() {
      if (localStorage) {
	localStorage.setItem("cw_feedzilla_subcategory", jQuery("#cw_feedzilla_subcategories").val());
	getSubcategories();
      }
    });

    vOrder = "relevance";
    if (localStorage) {
      vOrder = localStorage.getItem("cw_feedzilla_order");
    }

    if (vOrder == "date") {
      jQuery("#cw_feedzilla_order_date").prop('checked', true);
    } else {
      jQuery("#cw_feedzilla_order_relevance").prop('checked', true);
    }

   jQuery("#cw_feedzilla_order_relevance").change(function () {
     console.log("Relevance changed");
     if (localStorage) {
       if (jQuery(this).is(":checked")) {
         localStorage.setItem("cw_feedzilla_order", "relevance");
       }
     }
   });

   jQuery("#cw_feedzilla_order_date").change(function () {
     console.log("Date changed");
     if (localStorage) {
       if (jQuery(this).is(":checked")) {
         localStorage.setItem("cw_feedzilla_order", "date");
       }
     }
   });

    jQuery("#cw_feedzilla_refresh").on("click", function() {
      jQuery("#cw_feedzilla_loading").show();
      jQuery("#cw_feedzilla_messages").hide();
      getArticles();
    });
  }
});

function getCultures() {
  jQuery.ajax ({
    type: "post", 
    url: ajax_object.ajax_url,
    data: { action: "cw_feedzilla_cultures" },
    error: function(aObject, aTextStatus, aErrorThrown) {
      if (mRetryCount++ >= 3) {
        jQuery("#cw_feedzilla_loading").hide(400);
        jQuery("#cw_feedzilla_messages").show();
        jQuery("#cw_feedzilla_messages").html("Error retrieving cultures: " + aTextStatus + ": " + aErrorThrown + "\nPlease refresh the page.");
      } else {
        getCultures();
      }
    },
    success: function (aHtml) {
      jQuery("#cw_feedzilla_cultures").html(aHtml);
      if (localStorage) {
        vSelectedCulture = localStorage.getItem("cw_feedzilla_culture");
        if (!vSelectedCulture) {
          vSelectedCulture = 'en_us';
        }
      } else {
        vSelectedCulture = 'en_us';
      }
      jQuery("#cw_feedzilla_cultures").val(vSelectedCulture);
    }
  });
}

function getCategories() {
  if (localStorage) {
    vSelectedCulture = localStorage.getItem("cw_feedzilla_culture");
    if (!vSelectedCulture) {
      vSelectedCulture = 'en_us';
    }
  } else {
    vSelectedCulture = 'en_us';
  }

  jQuery.ajax ({
    type: "post", 
    url: ajax_object.ajax_url,
    data: { action: "cw_feedzilla_categories", culture_code: vSelectedCulture },
    error: function(aObject, aTextStatus, aErrorThrown) {
      if (mRetryCount++ >= 3) {
        jQuery("#cw_feedzilla_loading").hide(400);
        jQuery("#cw_feedzilla_messages").show();
        jQuery("#cw_feedzilla_messages").html("Error retrieving categories: " + aTextStatus + ": " + aErrorThrown + "\nPlease refresh the page.");
      } else {
        getCategories();
      }
    },
    success: function (aHtml) {
      jQuery("#cw_feedzilla_categories").html(aHtml);
      if (localStorage) {
        vSelectedCategory = localStorage.getItem("cw_feedzilla_category");
        if (!vSelectedCategory) {
          vSelectedCategory = '';
        }
      } else {
        vSelectedCategory = '';
      }
      jQuery("#cw_feedzilla_categories").val(vSelectedCategory);
    }
  });
}

function getSubcategories() {
  if (localStorage) {
    vSelectedCategory = localStorage.getItem("cw_feedzilla_category");
    if (!vSelectedCategory) {
      vSelectedCategory = '19';
    }
  } else {
    vSelectedCategory = '19';
  }

  jQuery.ajax ({
    type: "post", 
    url: ajax_object.ajax_url,
    data: { action: "cw_feedzilla_subcategories", category_code: vSelectedCategory },
    error: function(aObject, aTextStatus, aErrorThrown) {
      if (mRetryCount++ >= 3) {
        jQuery("#cw_feedzilla_messages").show();
        jQuery("#cw_feedzilla_messages").html("Error retrieving subcategories: " + aTextStatus + ": " + aErrorThrown + "\nPlease refresh the page.");
      } else {
        getSubcategories();
      }
    },
    success: function (aHtml) {
      jQuery("#cw_feedzilla_subcategories").html(aHtml);
      if (localStorage) {
        vSelectedSubcategory = localStorage.getItem("cw_feedzilla_subcategory");
        if (!vSelectedSubcategory) {
          vSelectedSubcategory = '';
        }
      } else {
        vSelectedSubcategory = '';
      }
      jQuery("#cw_feedzilla_subcategories").val(vSelectedSubcategory);
    }
  });
}

function getArticles() {
  vSelectedCategory = '1070';
  vSelectedSubcategory = '27839';
  vOrder = "relevance";

  if (localStorage) {
    vSelectedCategory = localStorage.getItem("cw_feedzilla_category");
    vSelectedSubcategory = localStorage.getItem("cw_feedzilla_subcategory");
    vOrder = localStorage.getItem("cw_feedzilla_order");
  }

  vSearchTerm = jQuery("#cw_feedzilla_search").val();

  jQuery.ajax ({
    type: "post", 
    url: ajax_object.ajax_url,
    data: { action: "cw_feedzilla_refresh", category_code: vSelectedCategory, subcategory_code: vSelectedSubcategory, search_term: vSearchTerm, order: vOrder },
    error: function(aObject, aTextStatus, aErrorThrown) {
      if (mRetryCount++ >= 3) {
        jQuery("#cw_feedzilla_loading").hide(400);
        jQuery("#cw_feedzilla_messages").show();
        jQuery("#cw_feedzilla_messages").html("Error retrieving articles: " + aTextStatus + ": " + aErrorThrown + "\nPlease refresh the page.");
      } else {
        getArticles();
      }
    },
    success: function (aHtml) {
      jQuery("#cw_feedzilla_headline_list").html(aHtml);
      jQuery("#cw_feedzilla_loading").hide(400);
    }
  });
}
